# TODO: Add comment
# 
# Author: Judith Zaugg
###############################################################################

pamClustering=function(mat=NULL,C=10,annoTab=NULL,projectfolder=getwd(),label){
	if(is.list(mat)){
		matL=mat
		mats=do.call(cbind,matL)
		if(length(grep('_',colnames(mats)))==0){
			colnames(mats)=paste(colnames(mats),rep(1:length(matL),rep(ncol(matL[[1]]),length(matL))),sep='_')
		}
		mat=mats
	}
	require(cluster)
#  folder checking
	projectfolder=gsub('/$','',projectfolder)
	cat(createFolderIfNotExist(projectfolder))
# load annoTab if not supplied
	annoTab=loadAnnoTab(projectfolder,annoTabID=annoTab)
	
#	annoTab=subset(tssT,exp.YPD.cat=='on'&!m1.excl.YPD&type=='ORF-T'&!is.na(rowMeans(matP,na.rm=TRUE)))
	clusterTab=annoTab[,c('strand','first','last','id','seqName')]
	mat=mat[rownames(mat)%in%clusterTab$id,]

# replace NA's with 0's
	vec=as.vector(mat)
	vec[is.na(vec)]=0
	mat2=matrix(vec,ncol=ncol(mat),nrow=nrow(mat))
	colnames(mat2)=colnames(mat)
	rownames(mat2)=rownames(mat)
	mat=mat2
	print(dim(mat))
# do the k-means clustering for promoters and gene bodies together
	cat('pam clustering with',C,'clusters...')
	cc=pam(mat,C)
	cat('done\n')
	matchMat=match(clusterTab$id,rownames(mat))
	clusterTab$clustering=cc$clustering[matchMat]
	clusterTab$silinfo=cc$silinfo$widths[match(1:nrow(clusterTab),as.numeric(rownames(cc$silinfo$widths))),3][matchMat]
# save important data
	logfile=paste(projectfolder,'AGP.log',sep='/')
	clusterfile=paste(projectfolder,'clusterTab.rda',sep='/')
	matrixfile=paste(projectfolder,'mat.rda',sep='/')
	cat('clustering:',C,'clusters','saved in',clusterfile,'\n',file=logfile)
	cat('matrix:',C,'data matrix','saved in',matrixfile,'\n',file=logfile)
	save(mat, file=matrixfile)
	save(clusterTab, file=clusterfile)
	return(c(matrixfile,clusterfile))
}



